"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var range_1 = require("./utils/range");
var BackgroundTypeEnum;
(function (BackgroundTypeEnum) {
    BackgroundTypeEnum["Vertical"] = "vertical";
    BackgroundTypeEnum["Horizontal"] = "horizontal";
})(BackgroundTypeEnum = exports.BackgroundTypeEnum || (exports.BackgroundTypeEnum = {}));
var Background = /** @class */ (function (_super) {
    __extends(Background, _super);
    function Background(props) {
        var _this = _super.call(this, props) || this;
        _this.canvas = document.createElement('canvas');
        _this._getBackground = function () {
            var _a = _this.props, type = _a.type, manager = _a.manager, _b = _a.range, start = _b.start, end = _b.end, color = _a.color, width = _a.width, height = _a.height;
            var isHirizontal = type === BackgroundTypeEnum.Horizontal;
            _this.canvas.height = isHirizontal ? height : 1;
            _this.canvas.width = isHirizontal ? 1 : width;
            var context = _this.canvas.getContext('2d');
            if (start >= end || !context) {
                return '';
            }
            context.fillStyle = color;
            var delta = manager.getPixelByIndex(start);
            for (var _i = 0, _c = range_1.default(start, end); _i < _c.length; _i++) {
                var index = _c[_i];
                var size = manager.getSize(index);
                if (!size) {
                    continue;
                }
                var startPixel = manager.getPixelByIndex(index) - 1;
                var endPixel = manager.getPixelByIndex(index) + size - 1;
                isHirizontal ? context.fillRect(0, startPixel - delta, 1, 1) : context.fillRect(startPixel - delta, 0, 1, 1);
                isHirizontal ? context.fillRect(0, endPixel - delta, 1, 1) : context.fillRect(endPixel - delta, 0, 1, 1);
            }
            return "url(" + _this.canvas.toDataURL() + ")";
        };
        if (props.type === BackgroundTypeEnum.Horizontal) {
            _this.canvas.width = 1;
        }
        else {
            _this.canvas.height = 1;
        }
        _this.canvas.height = props.type === BackgroundTypeEnum.Horizontal ? props.height : 1;
        _this.canvas.width = props.type === BackgroundTypeEnum.Horizontal ? 1 : props.width;
        return _this;
    }
    Background.prototype.componentWillUnmount = function () {
        this.canvas.remove();
    };
    Background.prototype.render = function () {
        var _a = this.props, type = _a.type, width = _a.width, height = _a.height, top = _a.top, left = _a.left;
        return (React.createElement("div", { className: type, style: {
                position: 'absolute',
                pointerEvents: 'none',
                zIndex: -1,
                width: width + "px",
                height: height + "px",
                top: top + "px",
                left: left + "px",
                background: this._getBackground(),
            } }));
    };
    return Background;
}(React.PureComponent));
exports.default = Background;
