"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var permutations_1 = require("./utils/permutations");
var range_1 = require("./utils/range");
var GridContent = /** @class */ (function (_super) {
    __extends(GridContent, _super);
    function GridContent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getStyle = function (_a) {
            var _b = _a.rowIndex, rowIndex = _b === void 0 ? 0 : _b, _c = _a.columnIndex, columnIndex = _c === void 0 ? 0 : _c;
            return ({
                position: 'absolute',
                top: _this.props.rowManager.getPixelByIndex(rowIndex) + "px",
                left: _this.props.columnManager.getPixelByIndex(columnIndex) + "px",
                height: _this.props.rowManager.getSize(rowIndex) + "px",
                width: _this.props.columnManager.getSize(columnIndex) + "px",
                boxSizing: 'border-box',
            });
        };
        _this.getCells = function () {
            var _a = _this.props, CellRenderer = _a.cellRenderer, rowsRange = _a.rowsRange, columnsRange = _a.columnsRange, rowManager = _a.rowManager, columnManager = _a.columnManager;
            if (CellRenderer) {
                var cellsCoods = permutations_1.default(range_1.default(columnsRange.start, columnsRange.end), range_1.default(rowsRange.start, rowsRange.end));
                return cellsCoods.map(function (_a) {
                    var columnIndex = _a[0], rowIndex = _a[1];
                    var key = rowIndex + ":" + columnIndex;
                    return (React.createElement(CellRenderer, { key: key, rowManager: rowManager, columnManager: columnManager, rowIndex: rowIndex, columnIndex: columnIndex, getStyle: _this.getStyle }));
                });
            }
            return null;
        };
        _this.getRange = function () {
            var _a = _this.props, RangeRenderer = _a.rangeRenderer, rowsRange = _a.rowsRange, columnsRange = _a.columnsRange, rowManager = _a.rowManager, columnManager = _a.columnManager;
            return RangeRenderer && (React.createElement(RangeRenderer, { rowManager: rowManager, columnManager: columnManager, startRowIndex: rowsRange.start, endRowIndex: rowsRange.end, startColumnIndex: columnsRange.start, endColumnIndex: columnsRange.end, getStyle: _this.getStyle }));
        };
        return _this;
    }
    GridContent.prototype.render = function () {
        return (React.createElement(React.Fragment, null,
            this.getCells(),
            this.getRange()));
    };
    return GridContent;
}(React.PureComponent));
exports.default = GridContent;
