"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ScrollWrapper = /** @class */ (function (_super) {
    __extends(ScrollWrapper, _super);
    function ScrollWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = React.createRef();
        _this.setPosition = function () {
            if (!_this.ref.current) {
                return;
            }
            var _a = _this.props, scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft;
            _this.ref.current.scrollTop = scrollTop;
            _this.ref.current.scrollLeft = scrollLeft;
        };
        return _this;
    }
    ScrollWrapper.prototype.componentDidMount = function () { this.setPosition(); };
    ScrollWrapper.prototype.componentDidUpdate = function () { this.setPosition(); };
    ScrollWrapper.prototype.render = function () {
        var _a = this.props, width = _a.width, height = _a.height, onScroll = _a.onScroll, children = _a.children, fullWidth = _a.fullWidth, fullHeight = _a.fullHeight;
        var child = React.Children.only(children);
        return (React.createElement("div", { role: "scroll-area", ref: this.ref, style: {
                height: height + "px",
                width: width + "px",
                overflow: 'auto',
                overflowX: width === fullWidth ? 'hidden' : 'auto',
                overflowY: height === fullHeight ? 'hidden' : 'auto',
            }, onScroll: onScroll }, React.cloneElement(child, { style: __assign(__assign({}, child.props.style), { position: 'relative' }) })));
    };
    return ScrollWrapper;
}(React.PureComponent));
exports.default = ScrollWrapper;
