"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ScrollbarType;
(function (ScrollbarType) {
    ScrollbarType[ScrollbarType["Vertical"] = 0] = "Vertical";
    ScrollbarType[ScrollbarType["Horizontal"] = 1] = "Horizontal";
})(ScrollbarType = exports.ScrollbarType || (exports.ScrollbarType = {}));
var getScrollbarWrapperStyle = function (_a) {
    var type = _a.type, _b = _a.scrollbarSize, scrollbarSize = _b === void 0 ? 10 : _b, visibleContentSize = _a.visibleContentSize, fullContentSize = _a.fullContentSize, scrollPosition = _a.scrollPosition;
    var style = { position: 'absolute' };
    if (type === ScrollbarType.Horizontal) {
        style.left = 0;
        style.bottom = 0;
        style.width = visibleContentSize + "px";
        style.height = scrollbarSize + "px";
    }
    if (type === ScrollbarType.Vertical) {
        style.right = 0;
        style.top = 0;
        style.height = visibleContentSize + "px";
        style.width = scrollbarSize + "px";
    }
    return style;
};
var getScrollbarStyle = function (_a) {
    var type = _a.type, visibleContentSize = _a.visibleContentSize, fullContentSize = _a.fullContentSize, scrollPosition = _a.scrollPosition, _b = _a.scrollbarColor, scrollbarColor = _b === void 0 ? '#aaa' : _b;
    var style = { position: 'absolute', borderRadius: '50%', backgroundColor: scrollbarColor };
    if (type === ScrollbarType.Horizontal) {
        style.height = '100%';
        style.top = 0;
        style.left = Math.min(visibleContentSize - 10, Math.floor((scrollPosition / fullContentSize) * visibleContentSize)) + "px";
        style.width = Math.max(Math.floor(visibleContentSize * (visibleContentSize / fullContentSize)), 10) + "px";
    }
    if (type === ScrollbarType.Vertical) {
        style.width = '100%';
        style.left = 0;
        style.top = Math.min(visibleContentSize - 10, Math.floor((scrollPosition / fullContentSize) * visibleContentSize)) + "px";
        style.height = Math.max(Math.floor(visibleContentSize * (visibleContentSize / fullContentSize)), 10) + "px";
    }
    return style;
};
var Scrollbar = /** @class */ (function (_super) {
    __extends(Scrollbar, _super);
    function Scrollbar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Scrollbar.prototype.render = function () {
        return (React.createElement("div", { role: "scrollbar-wrapper", style: getScrollbarWrapperStyle(this.props) },
            React.createElement("div", { role: "scrollbar", style: getScrollbarStyle(this.props) })));
    };
    return Scrollbar;
}(React.PureComponent));
exports.default = Scrollbar;
