"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var SizeAndPositionManager_1 = require("../managers/SizeAndPositionManager");
var RenderRangersManager_1 = require("../managers/RenderRangersManager");
var Background_1 = require("./Background");
var GridContent_1 = require("./GridContent");
var ScrollableArea_1 = require("./ScrollableArea");
var getPrevProps = function (props) {
    var width = props.width, height = props.height, rowCount = props.rowCount, rowHeight = props.rowHeight, rowManager = props.rowManager, columnCount = props.columnCount, columnWidth = props.columnWidth, columnManager = props.columnManager, overscanCount = props.overscanCount, overscanRowCount = props.overscanRowCount, overscanColumnCount = props.overscanColumnCount, scrollToRow = props.scrollToRow, scrollToColumn = props.scrollToColumn, scrollLeft = props.scrollLeft, scrollTop = props.scrollTop;
    return {
        width: width, height: height,
        rowCount: rowCount, rowHeight: rowHeight, rowManager: rowManager,
        columnCount: columnCount, columnWidth: columnWidth, columnManager: columnManager,
        overscanCount: overscanCount, overscanRowCount: overscanRowCount, overscanColumnCount: overscanColumnCount,
        scrollToRow: scrollToRow, scrollToColumn: scrollToColumn,
        scrollLeft: scrollLeft, scrollTop: scrollTop,
    };
};
var getChangedProps = function (props, prevProps) {
    return Object.keys(prevProps).some(function (key) { return props[key] !== prevProps[key]; });
};
var scrollFromProps = function (props, state) {
    var onScroll = props.onScroll;
    var scrollLeft = state.scrollLeft, scrollTop = state.scrollTop;
    if (onScroll && (props.scrollLeft !== scrollLeft || props.scrollTop !== scrollTop)) {
        onScroll({ scrollLeft: scrollLeft, scrollTop: scrollTop });
    }
};
var getRowManager = function (props, state) {
    if (!props.rowManager && (props.rowHeight !== state.prevProps.rowHeight || props.rowCount !== state.prevProps.rowCount)) {
        return new SizeAndPositionManager_1.default(props.rowCount, props.rowHeight, props.rowsCountToAdd);
    }
    return props.rowManager || state.rowManager;
};
var getColumnManager = function (props, state) {
    if (!props.columnManager && (props.columnWidth !== state.prevProps.columnWidth || props.columnCount !== state.prevProps.columnCount)) {
        return new SizeAndPositionManager_1.default(props.columnCount, props.columnWidth, props.columnsCountToAdd);
    }
    return props.columnManager || state.columnManager;
};
var Grid = /** @class */ (function (_super) {
    __extends(Grid, _super);
    function Grid(props) {
        var _this = _super.call(this, props) || this;
        _this.onScroll = function (_a, event) {
            var scrollTop = _a.scrollTop, scrollLeft = _a.scrollLeft;
            var scrollTopDelta = _this.state.scrollTop - scrollTop;
            var rowScrollType = scrollTopDelta === 0 ? _this.state.rowScrollType : scrollTopDelta < 0 ? RenderRangersManager_1.ScrollTypeEnum.After : RenderRangersManager_1.ScrollTypeEnum.Before;
            var scrollLeftDelta = _this.state.scrollLeft - scrollLeft;
            var columnScrollType = scrollLeftDelta === 0 ? _this.state.columnScrollType : scrollLeftDelta < 0 ? RenderRangersManager_1.ScrollTypeEnum.After : RenderRangersManager_1.ScrollTypeEnum.Before;
            if (_this.props.onScroll) {
                if (rowScrollType !== _this.state.rowScrollType || columnScrollType !== _this.state.columnScrollType) {
                    _this.setState({ rowScrollType: rowScrollType, columnScrollType: columnScrollType }, function () { return _this.props.onScroll({ scrollTop: scrollTop, scrollLeft: scrollLeft }, event); });
                }
                else {
                    _this.props.onScroll({ scrollTop: scrollTop, scrollLeft: scrollLeft }, event);
                }
            }
            else {
                var _b = _this.props, width = _b.width, height = _b.height;
                var _c = _this.state, renderRangesManager = _c.renderRangesManager, rowManager = _c.rowManager, columnManager = _c.columnManager, overscanRowCount = _c.overscanRowCount, overscanColumnCount = _c.overscanColumnCount;
                _this.setState({
                    scrollTop: scrollTop,
                    scrollLeft: scrollLeft,
                    rowScrollType: rowScrollType,
                    columnScrollType: columnScrollType,
                    rowsRange: renderRangesManager.getRowsRange(rowManager, scrollTop, height, overscanRowCount, rowScrollType),
                    columnsRange: renderRangesManager.getColumnsRange(columnManager, scrollLeft, width, overscanColumnCount, columnScrollType),
                });
            }
        };
        var width = props.width, height = props.height, rowCount = props.rowCount, rowHeight = props.rowHeight, _a = props.rowManager, rowManager = _a === void 0 ? new SizeAndPositionManager_1.default(rowCount, rowHeight) : _a, columnCount = props.columnCount, columnWidth = props.columnWidth, _b = props.columnManager, columnManager = _b === void 0 ? new SizeAndPositionManager_1.default(columnCount, columnWidth) : _b, _c = props.overscanCount, overscanCount = _c === void 0 ? 0 : _c, _d = props.overscanRowCount, overscanRowCount = _d === void 0 ? overscanCount : _d, _e = props.overscanColumnCount, overscanColumnCount = _e === void 0 ? overscanCount : _e, scrollToRow = props.scrollToRow, scrollToColumn = props.scrollToColumn;
        var _f = props.scrollLeft, scrollLeft = _f === void 0 ? 0 : _f, _g = props.scrollTop, scrollTop = _g === void 0 ? 0 : _g;
        if (scrollToRow !== undefined) {
            scrollTop = rowManager.getPixelByIndex(scrollToRow);
        }
        if (scrollToColumn !== undefined) {
            scrollLeft = columnManager.getPixelByIndex(scrollToColumn);
        }
        var renderRangesManager = new RenderRangersManager_1.default();
        _this.state = {
            prevProps: getPrevProps(props),
            renderRangesManager: renderRangesManager,
            rowManager: rowManager,
            columnManager: columnManager,
            overscanRowCount: overscanRowCount,
            overscanColumnCount: overscanColumnCount,
            scrollLeft: scrollLeft,
            scrollTop: scrollTop,
            rowsRange: renderRangesManager.getRowsRange(rowManager, scrollTop, height, overscanRowCount),
            columnsRange: renderRangesManager.getColumnsRange(columnManager, scrollLeft, width, overscanColumnCount),
        };
        return _this;
    }
    Grid.getDerivedStateFromProps = function (props, state) {
        var hasChanges = getChangedProps(props, state.prevProps);
        if (!hasChanges) {
            return null;
        }
        var changedState = { prevProps: getPrevProps(props) };
        var rowManager = getRowManager(props, state);
        var rowManagerChanged = state.rowManager !== rowManager;
        if (rowManagerChanged) {
            changedState.rowManager = rowManager;
        }
        var columnManager = getColumnManager(props, state);
        var columnManagerChanged = state.columnManager !== columnManager;
        if (columnManagerChanged) {
            changedState.columnManager = columnManager;
        }
        var scrollTop = (props.scrollTop === undefined ? state.scrollTop : props.scrollTop) || 0;
        var rowScrollType = state.rowScrollType;
        if (props.scrollToRow !== state.prevProps.scrollToRow && props.scrollToRow !== undefined) {
            rowScrollType = changedState.rowScrollType = undefined;
            var rowPixel = rowManager.getPixelByIndex(props.scrollToRow);
            var rowSize = rowManager.getSize(props.scrollToRow);
            if (rowPixel < scrollTop) {
                scrollTop = rowPixel;
            }
            else if (rowPixel + rowSize > scrollTop + props.height) {
                scrollTop = Math.max(0, rowPixel - props.height + rowSize);
            }
        }
        if (state.scrollTop !== scrollTop || rowManagerChanged || props.height !== state.prevProps.height) {
            var overscanRowCount = props.overscanRowCount || props.overscanCount || 0;
            var rowsRange = state.renderRangesManager.getRowsRange(rowManager, scrollTop, props.height, overscanRowCount, rowScrollType);
            if (rowsRange !== state.rowsRange) {
                changedState.rowsRange = rowsRange;
            }
            if (overscanRowCount !== state.overscanRowCount) {
                changedState.overscanRowCount = overscanRowCount;
            }
        }
        var scrollLeft = (props.scrollLeft === undefined ? state.scrollLeft : props.scrollLeft) || 0;
        var columnScrollType = state.columnScrollType;
        if (props.scrollToColumn !== state.prevProps.scrollToColumn && props.scrollToColumn !== undefined) {
            columnScrollType = changedState.columnScrollType = undefined;
            var columnPixel = columnManager.getPixelByIndex(props.scrollToColumn);
            var columnSize = columnManager.getSize(props.scrollToColumn);
            if (columnPixel < scrollLeft) {
                scrollLeft = columnPixel;
            }
            else if (columnPixel + columnSize > scrollLeft + props.width) {
                scrollLeft = Math.max(0, columnPixel - props.width + columnSize);
            }
        }
        if (state.scrollLeft !== scrollLeft || columnManagerChanged || props.width !== state.prevProps.width) {
            var overscanColumnCount = props.overscanColumnCount || props.overscanCount || 0;
            var columnsRange = state.renderRangesManager.getColumnsRange(columnManager, scrollLeft, props.width, overscanColumnCount, columnScrollType);
            if (columnsRange !== state.columnsRange) {
                changedState.columnsRange = columnsRange;
            }
            if (state.overscanColumnCount !== overscanColumnCount) {
                changedState.overscanColumnCount = overscanColumnCount;
            }
        }
        if (state.scrollTop !== scrollTop) {
            changedState.scrollTop = scrollTop;
        }
        if (state.scrollLeft !== scrollLeft) {
            changedState.scrollLeft = scrollLeft;
        }
        return changedState;
    };
    Grid.prototype.componentDidMount = function () {
        scrollFromProps(this.props, this.state);
    };
    Grid.prototype.componentDidUpdate = function () {
        scrollFromProps(this.props, this.state);
    };
    Grid.prototype.render = function () {
        var _a = this.props, _b = _a.ScrollComponent, ScrollComponent = _b === void 0 ? ScrollableArea_1.default : _b, height = _a.height, width = _a.width, children = _a.children, _c = _a.enableBackgroundLines, enableBackgroundLines = _c === void 0 ? false : _c, _d = _a.enableBackgroundVerticalLines, enableBackgroundVerticalLines = _d === void 0 ? enableBackgroundLines : _d, _e = _a.enableBackgroundHorizontalLines, enableBackgroundHorizontalLines = _e === void 0 ? enableBackgroundLines : _e, _f = _a.backgroundLinesColor, backgroundLinesColor = _f === void 0 ? '#e7e7e7' : _f, _g = _a.verticalBackgroundLinesColor, verticalBackgroundLinesColor = _g === void 0 ? backgroundLinesColor : _g, _h = _a.horizontalBackgroundLinesColor, horizontalBackgroundLinesColor = _h === void 0 ? backgroundLinesColor : _h, cellRenderer = _a.cellRenderer, rangeRenderer = _a.rangeRenderer;
        var _j = this.state, scrollLeft = _j.scrollLeft, scrollTop = _j.scrollTop, rowManager = _j.rowManager, columnManager = _j.columnManager, rowsRange = _j.rowsRange, columnsRange = _j.columnsRange;
        return (React.createElement(ScrollComponent, { width: width, height: height, onScroll: this.onScroll, scrollLeft: scrollLeft, scrollTop: scrollTop, fullHeight: rowManager.fullSize, fullWidth: columnManager.fullSize },
            enableBackgroundVerticalLines &&
                (React.createElement(Background_1.default, { manager: columnManager, range: columnsRange, type: Background_1.BackgroundTypeEnum.Vertical, color: verticalBackgroundLinesColor, width: columnManager.getPixelByIndex(columnsRange.end) - columnManager.getPixelByIndex(columnsRange.start) + columnManager.getSize(columnsRange.end), height: rowManager.getPixelByIndex(rowsRange.end) - rowManager.getPixelByIndex(rowsRange.start) + rowManager.getSize(rowsRange.end), top: rowManager.getPixelByIndex(rowsRange.start), left: columnManager.getPixelByIndex(columnsRange.start) })),
            enableBackgroundHorizontalLines && (React.createElement(Background_1.default, { manager: rowManager, range: rowsRange, type: Background_1.BackgroundTypeEnum.Horizontal, color: horizontalBackgroundLinesColor, width: columnManager.getPixelByIndex(columnsRange.end) - columnManager.getPixelByIndex(columnsRange.start) + columnManager.getSize(columnsRange.end), height: rowManager.getPixelByIndex(rowsRange.end) - rowManager.getPixelByIndex(rowsRange.start) + rowManager.getSize(rowsRange.end), top: rowManager.getPixelByIndex(rowsRange.start), left: columnManager.getPixelByIndex(columnsRange.start) })),
            React.createElement(GridContent_1.default, { rowManager: rowManager, columnManager: columnManager, rowsRange: rowsRange, columnsRange: columnsRange, cellRenderer: cellRenderer, rangeRenderer: rangeRenderer }),
            children));
    };
    return Grid;
}(React.PureComponent));
exports.default = Grid;
