interface TreeNodeParams {
    start: number;
    end: number;
    index: number;
}
export declare class TreeNode {
    private start;
    private end;
    private _index;
    private _left?;
    private _right?;
    constructor({ start, end, index }: TreeNodeParams);
    readonly index: number;
    readonly left: TreeNode;
    readonly right: TreeNode;
    private readonly leftHeight;
    private readonly rightHeight;
    readonly height: number;
    private rotateRight;
    private rotateLeft;
    private balanceTree;
    add({ start, end, index }: TreeNodeParams): TreeNode;
    get(pixel: number): number;
}
export default class IndexCache {
    private treeNode?;
    set(params: TreeNodeParams): void;
    get(pixel: number): number;
    has(pixel: number): boolean;
}
export {};
